Subject: Re: bug#51733: 27.1; Detect impossible email addresses better

From: Eli Zaretskii <[email-masked]>
Date: Wed, 10 Nov 2021 15:39:48 +0200

> From: Lars Ingebrigtsen <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Wed, 10 Nov 2021 05:44:05 +0100
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> >> Do we have a predicate somewhere that says whether a string is suspicious
> >> based on confusables and r2l markers and stuff?
> >
> > No.  We have the infrastructure for detecting the reordering, though.
> 
> I thought I vaguely remembered you writing something in this area in
> conjunction with some URL stuff some years back, but I don't recall what
> happened to it.

I did write it, that's bidi-find-overridden-directionality, which we
have since Emacs 25.  That is what I meant by "detecting the
reordering".  Detecting confusables in general is a much broader
issue, not limited to bidi reordering alone.

> Hm...  and there's uni-confusables in GNU ELPA?  Should we have that in
> core instead?  (Or in addition.)

We could add that to core, but currently uni-confusables just gives
you a char-table which Lisp programs can use to find out whether a
given character is a potential confusable.  We need applications
layers above that, ideally implementing at least part of the
recommendations in Unicode's UTS #39
(https://www.unicode.org/reports/tr39/).  We should probably first
discuss what we want to implement from there, though.  How about
chiming in to emacs-devel thread "Unicode confusables considered
harmful", where Vasilij Schneidermann already asked what we think
should be done about these cases?